/*
 * Sixth Data. Copyright ©2012-2018, Svjatoslav Agejenko, svjatoslav@svjatoslav.eu
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of version 3 of the GNU Lesser General Public License
 * or later as published by the Free Software Foundation.
 */

package eu.svjatoslav.sixth.data.model;

public class ArrayStorage {

    // load 16bit integer from byte array
    public static int load16bit(final byte[] array, final int addr) {
        // return (int)array[addr] + (int)array[addr+1]*256;
        return ((array[addr + 1] & 0xFF) << 8) | (array[addr] & 0xFF);
    }

    // load 16bit integer from byte array
    public static int load32bit(final byte[] array, final int addr) {
        return ((array[addr + 3] & 0xFF) << 24)
                | ((array[addr + 2] & 0xFF) << 16)
                | ((array[addr + 1] & 0xFF) << 8) | (array[addr] & 0xFF);
    }

    // store 16bit integer into byte array
    public static void store16bit(final byte[] array, final int addr,
                                  final int value) {
        final int byteHigh = value / 256;
        final int byteLow = value - (byteHigh * 256);
        array[addr] = (byte) byteLow;
        array[addr + 1] = (byte) byteHigh;
    }

}
